// X10 Tester file
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "x10dll.h"

int main(void)
{
  // Turn on light E2
  CP290COMMAND cmd;
  CP290ICON cpIcon[256];
  char ErrorMsg[CP290ERR_MESSAGELENGTH];
  int lcv;

  printf("Initializing...");
  if (!CP290_Initialize("COM2"))
  {
	 printf("Error on initialize!\n");
  }
  else{printf("Done.");
  printf("House Code = %c\n", CP290_GetBaseHouseCode());
  printf("Sending X10 command...");
  cmd.DimLevel = 4;
  cmd.Command = CP290_ON;
  cmd.HouseCode = 'E';
  for (lcv = 0; lcv <= 15; lcv++)
	 cmd.Unit[lcv] = FALSE;
  cmd.Unit[6] = TRUE;
  if (!CP290_Control(&cmd))
  {
	 CP290_GetLastError(ErrorMsg);
	 printf("Error on control!  %s\n", ErrorMsg);
  }
  else
  {
	 SYSTEMTIME st;
	 int NumIcons = 256;
  cmd.Command = CP290_DIM;
  printf("Sending X10 command...");
  if (!CP290_Control(&cmd))
  {
	 CP290_GetLastError(ErrorMsg);
	 printf("Error on control!  %s\n", ErrorMsg);
  }
  cmd.Command = CP290_OFF;
  printf("Sending X10 command...");
  if (!CP290_Control(&cmd))
  {
	 CP290_GetLastError(ErrorMsg);
	 printf("Error on control!  %s\n", ErrorMsg);
  }
	 printf("Setting X10 time to computer clock...");
	 GetLocalTime(&st);
	 printf("Hours: %i, Minutes: %i, Day Id: %i\n", (int) st.wHour, (int) st.wMinute, (int) st.wDayOfWeek);

	 if (!CP290_SetTime(&st))
	 {
		CP290_GetLastError(ErrorMsg);
		printf("Error on time set!  %s\n", ErrorMsg);
	 }
		if (!CP290_GetTime(&st))
		{
		  CP290_GetLastError(ErrorMsg);
		  printf("Error on time get!  %s\n", ErrorMsg);
		}
		else
		  printf("Unit time:\nHours: %i, Minutes: %i, Day Id: %i\n", (int) st.wHour, (int) st.wMinute, (int) st.wDayOfWeek);

		printf("Setting Icon ");
		for (lcv=0; lcv <= 255; lcv++)
		{
		  cpIcon[lcv].IconId = (BYTE) lcv;
		  cpIcon[lcv].Data[0] = (BYTE) ((lcv + 1) * 2);
		  cpIcon[lcv].Data[1] = (BYTE) ((lcv + 1) / 2);
		  cpIcon[lcv].InUse = TRUE;
		  if (cpIcon[lcv].Data[0] == 0)
			 cpIcon[lcv].Data[0] = 45;
		  if (!CP290_SetIcon(&cpIcon[lcv]))
		  {
			 CP290_GetLastError(ErrorMsg);
			 printf("Error setting icon %i!  %s\n", lcv, ErrorMsg);
		  }
		  else
			 printf("%i ", lcv);
		  cpIcon[lcv].IconId = 0;
		  cpIcon[lcv].Data[0] = 0;
		  cpIcon[lcv].Data[1] = 0;
		}
		if (!CP290_GetTime(&st))
		{
		  CP290_GetLastError(ErrorMsg);
		  printf("Error on time get!  %s\n", ErrorMsg);
		}
		else
		  printf("Unit time:\nHours: %i, Minutes: %i, Day Id: %i\n", (int) st.wHour, (int) st.wMinute, (int) st.wDayOfWeek);
		// test icons
		if (!CP290_GetIcons(cpIcon, NumIcons))
		{
		  CP290_Uninitialize();
		  CP290_Initialize("COM2");
		  if (!CP290_GetIcons(cpIcon, NumIcons))
		  {
			 CP290_GetLastError(ErrorMsg);
			 printf("Cannot get icons!  %s\n", ErrorMsg);
		  }
      }
		{
		  for (lcv=0; lcv <= NumIcons - 1; lcv++)
		  {
			if (cpIcon[lcv].InUse)
			{
			 if (cpIcon[lcv].Data[0] == 45)
				cpIcon[lcv].Data[0] = 0;
			 if (cpIcon[lcv].IconId != lcv)
				printf("Icon %i: bad icon id=%i! ", lcv, (int) cpIcon[lcv].IconId);
			 else
				printf("Icon %i: Perfect Id=%i! ", lcv, (int) cpIcon[lcv].IconId);
			 if (cpIcon[lcv].Data[0] != (BYTE) ((lcv + 1) * 2))
				printf("Icon %i: bad icon byte0=%i! ", lcv, (int) cpIcon[lcv].Data[0]);
			 else
				printf("Icon %i: Perfect Data[0]=%i! ", lcv, (int) cpIcon[lcv].Data[0]);
			 if (cpIcon[lcv].Data[1] != (BYTE) ((lcv + 1) / 2))
				printf("Icon %i: bad icon byte1=%i\n", lcv, (int) cpIcon[lcv].Data[1]);
			 else
				printf("Icon %i: Perfect Data[1]=%i!\n", lcv, (int) cpIcon[lcv].Data[1]);
			}
			else
			 printf("Icon %i: Not in use", lcv);
		  }
		}
	 }
  }

  {
	 // Test the event set function
	 CP290TIMEREVENT evt;

	 evt.EventId = 127;
	 evt.Mode = CP290_CLEAR;
	 evt.Time.wHour = 17;
	 evt.Time.wMinute = 20;
	 for (lcv = 0; lcv <= 15; lcv++)
		evt.Unit[lcv] = FALSE;
	 evt.Unit[6] = TRUE;
//	 evt.Unit[0] = TRUE;
//	 evt.Unit[1] = TRUE;
	 for (lcv = 0; lcv <= 6; lcv++)
		evt.Day[lcv] = FALSE;
	 evt.Day[CP290_THURSDAY] = TRUE;
	 evt.HouseCode = 'E';
	 evt.DimLevel = 12;
	 evt.Command = CP290_DIM;
	 evt.InUse = TRUE;
	 if (!CP290_SetTimerEvent(&evt))
	 {
		CP290_GetLastError(ErrorMsg);
		printf("Cannot set event!  %s", ErrorMsg);
	 }
	 else
		printf("Wait for the lights to turn on soon...");
  }

  {
	 // Test the event get function
	 CP290TIMEREVENT evt[128];
	 int NumEvents = 128;
	 int altlcv;
	 if (!CP290_GetTimerEvents(evt, NumEvents))
	 {
		CP290_GetLastError(ErrorMsg);
		printf("Cannot get timer events!  %s\n", ErrorMsg);
	 }
	 else
	 {
		printf("Got them!\n");
		for (lcv=0; lcv <= NumEvents - 1; lcv++)
		{
		  if (evt[lcv].InUse)
		  {
			 if (evt[lcv].EventId != lcv)
				printf("Event %i: bad icon id=%i! ", lcv, (int) evt[lcv].EventId);
			 else
				printf("Event %i: Perfect Id=%i! ", lcv, (int) evt[lcv].EventId);
			 printf("Mode = %i, Minute = %hu, Hour = %hu, HouseCode = %c, DimLevel = %i, Command = %i\nUnits: ", (int)evt[lcv].Mode, evt[lcv].Time.wMinute, evt[lcv].Time.wHour, evt[lcv].HouseCode, (int)evt[lcv].DimLevel, (int)evt[lcv].Command);
			 for (altlcv = 0; altlcv <= 15; altlcv++)
				if (evt[lcv].Unit[altlcv])
				  printf("%i ", altlcv);
			 printf("  Days: ");
			 for (altlcv = 0; altlcv <= 6; altlcv++)
				if (evt[lcv].Day[altlcv])
				  printf("%i ", altlcv);
			 printf("\n");
		  }
		  else
			 printf("Event %i: Not in use\n", lcv);
		}
	 }

  }
  printf("House Code = %c\n", CP290_GetBaseHouseCode());
  CP290_Uninitialize();
  printf("\n\nPress any key to exit...");
  while (!kbhit());
  getch();
  return 0;
}

